/**
 * Created by vito on 15/12/10.
 */

var ConstantsExtra = {
    multiLevelReportingWD: "multiLevelReportingWD",
    multiLevelReportingPanelWD: "multiLevelReportingPanelWD",
    customRoleListNoCheckWD: "customRoleListNoCheckWD"
};
$.extend(FS.Plugin.MultiLevelReport, {

    pushItem: function (items) {
        if (FS.isPlatForm() && FS.config.templatePrivilegeType == "1") {
            items.push(this._ui());
        }
    },

    showPrivilege: function (roleId) {//显示勾选的状态
        var cacheEntryPrivileges = FS.PRIVILEGEMANAGER.CACHE.getEntryPrivilege(roleId);
        FS.Plugin.MultiLevelReport.ReMultitree = FS.PRIVILEGEMANAGER.VIEW.tabPane.getWidgetByName(ConstantsExtra.multiLevelReportingWD);
        FS.Plugin.MultiLevelReport.ReMultitree.clearState();
        var reportsForTree = [];
        for (var i = 0; i < cacheEntryPrivileges.length; i++) {
            var temp = $.extend({}, cacheEntryPrivileges[i]);
            if (temp.id && !("" + temp.id).startWith("0")) {
                temp.id = temp.type + "" + temp.id;
            }
            reportsForTree.push(temp);
        }
        this.ReMultitree.selectNodesByData(reportsForTree);
    },

    _ui: function () {
        var context = this._tab(ConstantsExtra.multiLevelReportingWD, 308, 374, 374, "entryTableTreeNoCheck", false, true, FS.PRIVILEGEMANAGER.showEntryAuth).content;
        return {
            el: {
                type: 'panel',
                fit: false,
                title: FR.i18nText("FS-Generic-Re_Multi_Privilege"),
                width: 308,
                height: 374,
                border: true,
                contentWidget: context,
                widgetName: ConstantsExtra.multiLevelReportingPanelWD
            }
        }
    },

    _tab: function (widgetName, tabWidth, contentWidth, contentHeight, treeID, viewOnly, hasTool, clickFunc) {
        var tools = [{
            name: 'view',
            //编辑按钮事件
            onToolClick: function (e, treeNode, isSelect) {
                if (FS.isGradeAuthorityOpen()) {
                    //有授权
                    if (!isSelect && (treeNode["design"] !== 0)) {
                        FS.PRIVILEGEMANAGER.VIEW.reportTableTree.cancelSelectedNodeWithCascade(treeNode, 1);
                    }
                }
                if (FS.isEditReportAuthorityOpen()) {
                    //有编辑
                    if (!isSelect && (treeNode["edit"] !== 0)) {
                        FS.PRIVILEGEMANAGER.VIEW.reportTableTree.cancelSelectedNodeWithCascade(treeNode, tools.length - 1);
                    }
                }
                e.stopEvent();
            }
        }];

        var reportSetting = this._getSetting(clickFunc, hasTool ? tools.length : 0);
        var toolConfig = {
            tooltype: 'check',
            toolMargin: 10,
            alwaysShowTools: true,
            tools: tools,
            onItemToolClick: function () {
                FS.Plugin.MultiLevelReport._saveCache();
            }
        }
        if (viewOnly) {
            toolConfig.toolUnEditAble = true;
        }
        var result = {
            title: FR.i18nText("FS-Generic-Simple_Report"),
            content: {
                type: 'fstabletree',
                height: contentHeight,
                width: contentWidth,
                treeID: treeID,
                setting: reportSetting,
                widgetName: widgetName
            },
            width: tabWidth
        }
        if (hasTool) {
            $.extend(result.content, toolConfig);
        }
        return result;
    },


    _getSetting: function (clickFunc, toolLength) {//显示控件数据，多级权限
        /**
         * 请求上报流程的三种标签
         * @returns {*|请求的结果}
         */
        function getReportProcessEntrys() {
            return FS.Trans.ajax({
                url: FR.servletURL + "?op=multi_report&cmd=get_reportProcessEntrys",
                data: {
                    serverID: FS.serverID
                }

            })
        };

        function _exists(processType, result) {
            for (var i = 0; i < result.length; i++) {
                if (result[i].processType === processType) {
                    return true;
                }
            }
            return false;
        };

        /**
         * 确保每种上报流程只有一个存在
         * @returns {Array} 过滤后的标签组
         */
        function difFilter() {
            var finalReport = [];
            var oriReport = getReportProcessEntrys();
            for (var i = 0, l = oriReport.length; i < l; i++) {
                if (!_exists(oriReport[i].processType, finalReport)) {
                    finalReport.push(oriReport[i]);
                }
            }
            return finalReport;
        };

        function filter(parentNode, node, newNodes, result) {
            var reportProcessEntrys = difFilter();
            if (!newNodes) {
                return null;
            }

            if (!result) {
                result = [];
            }
            for (var i = 0, l = newNodes.length; i < l; i++) {
                var item = newNodes[i];
                for (var j = 0, k = reportProcessEntrys.length; j < k; j++) {
                    if (reportProcessEntrys[j].id == item.id) {
                        var zItem = {};
                        zItem.id = item.id;
                        zItem.pId = item.parentID || item.parentId;
                        zItem.name = item.text;
                        zItem.open = false;
                        zItem.type = item.type;
                        zItem.description = item.description;
                        if (item.edit !== 1) {
                            zItem.toolDisAbleIndex = toolLength - 1;
                        }
                        if (FS.PRIVILEGEMANAGER.CONTROL._alreadyExists(zItem.id, result)) {
                            continue;
                        }
                        result.push(zItem);
                    }
                }
                if (item.ChildNodes && item.ChildNodes.length > 0) {
                    filter(parentNode, node, item.ChildNodes, result);
                }

            }
            return result;
        };
        return {
            async: {
                enable: true,
                url: FR.servletURL + "?op=fs_set&cmd=auth_getallreports",
                dataFilter: filter,
                data: {
                    serverID: FS.serverID
                }
            },
            view: {
                showIcon: false,  //不显示每个节点前的ICON
                selectedMulti: toolLength > 0
            },
            data: {
                simpleData: {
                    enable: true,
                    idKey: "id",
                    pidKey: "pId",
                    rootPId: "0-1"
                }
            },
            callback: {
                onClick: clickFunc,
                beforeClick: function () {
                    if (toolLength > 0) {
                        return false;
                    }
                }
            }
        };
    },

    _saveCache: function () {//多级上报缓存
        var roleId;
        roleId = FS.PRIVILEGEMANAGER.VIEW.tabPane.getWidgetByName(Constants.customRoleListNoCheckWD).getValue();
        if (roleId) {
            FS.PRIVILEGEMANAGER.CACHE.setEntryPrivilege(roleId, FS.Plugin.MultiLevelReport.ReMultitree.getSelectedNodes(), true);
        }
    }
});